! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine unset

  use condition_ini
  use gsp_parameter
  use rtbh_parameter
  use hamiltonian_temp
  use gf_se_c

  implicit none

  call unset_condition_ini_1

  if( ham_model_ini .eq. 'gsp' ) then
     call unset_condition_ini
     call unset_gsp_parameter
     call unset_pair_ini
  end if
  if( ham_model_ini .eq. 'rtb_h' ) then
     call unset_condition_ini
     call unset_rtbh_parameter
  end if
  if( ham_model_ini .eq. 'input' ) then
     call dealo_ham_negf_type_c
     call dealo_ham_negf_type_l
     call dealo_ham_negf_type_r
  end if
  if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
     call dealo_tr_negf_kpoint
  end if

  return
end subroutine unset

subroutine unset_c

  use condition_ini
  use locate_atom
  use hamiltonian_c

  implicit none

  call unset_hami_c
  call unset_locate_atom
  if( ham_model_ini .eq. 'gsp' ) then
     call unset_locate_atom_pair
  end if

  return
end subroutine unset_c
